<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: shoutbox_archive.php
| Author: Nick Jones (Digitanium)
+--------------------------------------------------------+
| CSS Shoutbox Panel
| Filename: css_shoutbox_archive.php
| Version: 1.00
| Author: Fangree Productions
| Developer: Fangree_Craig
| Site: http://www.fangree.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";

include_once INFUSIONS."shoutbox_panel/infusion_db.php";
include_once INCLUDES."infusions_include.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."css_shoutbox_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."css_shoutbox_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."css_shoutbox_panel/locale/English.php";
}

$shout_settings = get_settings("shoutbox_panel");

$archive_shout_link = ""; $archive_shout_message = "";

$result = dbquery("SELECT panel_access FROM ".DB_PANELS." WHERE panel_filename='css_shoutbox_panel' AND panel_status='1'");
if (dbrows($result)) {
	$data = dbarray($result);
	if (!checkgroup($data['panel_access'])) {
		redirect(BASEDIR."index.php");
	}
} else {
	redirect(BASEDIR."index.php");
}

if (iMEMBER && (isset($_GET['action']) && $_GET['action'] == "delete") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
	if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."' AND shout_hidden='0'"))) {
		$result = dbquery("DELETE FROM ".DB_SHOUTBOX." WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
	}
	redirect(FUSION_SELF);
}

function sbawrap($text) {
	global $locale;

	$i = 0; $tags = 0; $chars = 0; $res = "";

	$str_len = strlen($text);

	for ($i = 0; $i < $str_len; $i++) {
		$chr = mb_substr($text, $i, 1, $locale['charset']);
		if ($chr == "<") {
			if (mb_substr($text, ($i + 1), 6, $locale['charset']) == "a href" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "img") {
				$chr = " ".$chr;
				$chars = 0;
			}
			$tags++;
		} elseif ($chr == "&") {
			if (mb_substr($text, ($i + 1), 5, $locale['charset']) == "quot;") {
				$chars = $chars - 5;
			} elseif (mb_substr($text, ($i + 1), 4, $locale['charset']) == "amp;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#39;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#92;") {
				$chars = $chars - 4;
			} elseif (mb_substr($text, ($i + 1), 3, $locale['charset']) == "lt;" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "gt;") {
				$chars = $chars - 3;
			}
		} elseif ($chr == ">") {
			$tags--;
		} elseif ($chr == " ") {
			$chars = 0;
		} elseif (!$tags) {
			$chars++;
		}

		if (!$tags && $chars == 40) {
			$chr .= " ";
			$chars = 0;
		}
		$res .= $chr;
	}

	return $res;
}

add_to_title($locale['global_200'].$locale['SB_archive']);
include_once INFUSIONS."css_shoutbox_panel/includes/css_shoutbox_panel_head_functions.php";
opentable($locale['SB_archive']);
if (iMEMBER || $shout_settings['guest_shouts'] == "1") {
	include_once INCLUDES."bbcode_include.php";
	if (isset($_POST['post_archive_shout'])) {
		$flood = false;
		if (iMEMBER) {
			$archive_shout_name = $userdata['user_id'];
		} elseif ($shout_settings['guest_shouts'] == "1") {
			$archive_shout_name = trim(stripinput($_POST['archive_shout_name']));
			$archive_shout_name = preg_replace("(^[+0-9\s]*)", "", $archive_shout_name);
			if (isnum($archive_shout_name)) { $archive_shout_name = ""; }
			include_once INCLUDES."captchas/securimage/securimage.php";
			$securimage = new Securimage();
			if (!isset($_POST['captcha_code']) || $securimage->check($_POST['captcha_code']) == false) { redirect($link); }
		}
		$archive_shout_message = str_replace("\n", " ", $_POST['archive_shout_message']);
		$archive_shout_message = preg_replace("/^(.{255}).*$/", "$1", $archive_shout_message);
		$archive_shout_message = trim(stripinput(censorwords($archive_shout_message)));
		if (iMEMBER && (isset($_GET['action']) && $_GET['action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
			$comment_updated = false;
			if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."' AND shout_hidden='0'"))) {
				if ($archive_shout_message) {
					$result = dbquery("UPDATE ".DB_SHOUTBOX." SET shout_message='$archive_shout_message' WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
				}
			}
			redirect(FUSION_SELF);
		} elseif ($archive_shout_name && $archive_shout_message) {
			require_once INCLUDES."flood_include.php";
			if (!flood_control("shout_datestamp", DB_SHOUTBOX, "shout_ip='".USER_IP."'")) {
				$result = dbquery("INSERT INTO ".DB_SHOUTBOX." (shout_name, shout_message, shout_datestamp, shout_ip, shout_ip_type) VALUES ('$archive_shout_name', '$archive_shout_message', '".time()."', '".USER_IP."', '".USER_IP_TYPE."')");
			}
			redirect(FUSION_SELF);
		}
	}
	if (iMEMBER && (isset($_GET['action']) && $_GET['action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
		$esresult = dbquery(
			"SELECT ts.shout_id, ts.shout_name, ts.shout_message, tu.user_id, tu.user_name
			FROM ".DB_SHOUTBOX." ts
			LEFT JOIN ".DB_USERS." tu ON ts.shout_name=tu.user_id
			WHERE ts.shout_id='".$_GET['shout_id']."' AND shout_hidden='0'"
		);
		if (dbrows($esresult)) {
			$esdata = dbarray($esresult);
			if ((iADMIN && checkrights("S")) || (iMEMBER && $esdata['shout_name'] == $userdata['user_id'] && isset($esdata['user_name']))) {
				if ((isset($_GET['action']) && $_GET['action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
					$edit_url = "?action=edit&amp;shout_id=".$esdata['shout_id'];
				} else {
					$edit_url = "";
				}
				$archive_shout_link = FUSION_SELF.$edit_url;
				$archive_shout_message = $esdata['shout_message'];
			}
		} else {
			$archive_shout_link = FUSION_SELF;
			$archive_shout_message = "";
		}
	} else {
		$archive_shout_link = FUSION_SELF;
		$archive_shout_message = "";
	}
	echo "<form name='archive_form' method='post' action='".$archive_shout_link."'>\n";
	echo "<div style='text-align:center'>\n";
	if (iGUEST) {
		echo $locale['SB_name']."<br />\n";
		echo "<input type='text' name='archive_shout_name' value='' class='textbox' maxlength='30' style='width:200px;' /><br />\n";
		echo $locale['SB_message']."<br />\n";
	}
	
	echo"<div class='rules-message-sb-archive center'>
".$locale['fpsb_message']."</div>\n";
	echo"<textarea name='archive_shout_message' maxlength='200' rows='2' cols='50' id='counterc' class='textbox-sb-archive center'>".$archive_shout_message."</textarea><br />
	<span class='counter' ></span> <span class='counterc'>".$locale['sb_count2']."</span>\n";

	echo "<div style='text-align:center'>".display_bbcodes("100%", "archive_shout_message", "archive_form", "smiley|b|i|u|url|color")."</div>\n";
	if (iGUEST) {
		echo $locale['SB_validation_code']."<br />\n";
		echo "<img id='captcha' src='".INCLUDES."captchas/securimage/securimage_show.php' alt='' /><br />\n";
		echo "<a href='".INCLUDES."captchas/securimage/securimage_play.php'><img src='".INCLUDES."captchas/securimage/images/audio_icon.gif' alt='' class='tbl-border' style='margin-bottom:1px' /></a>\n";
		echo "<a href='#' onclick=\"document.getElementById('captcha').src = '".INCLUDES."captchas/securimage/securimage_show.php?sid=' + Math.random(); return false\"><img src='".INCLUDES."captchas/securimage/images/refresh.gif' alt='' class='tbl-border' /></a><br />\n";
		echo $locale['SB_enter_validation_code']."<br />\n<input type='text' name='captcha_code' class='textbox' style='width:100px' /><br />\n";
	}
	echo "<br /><input type='submit' name='post_archive_shout' value='".$locale['SB_shout']."' class='button' />\n";
	echo "</div>\n</form>\n<br />\n";
} else {
	echo "<div style='text-align:center'>".$locale['SB_login_req']."</div>\n";
}

$rows = dbcount("(shout_id)", DB_SHOUTBOX,"shout_hidden='0'");
if (!isset($_GET['rowstart']) || !isnum($_GET['rowstart'])) { $_GET['rowstart'] = 0; }
if ($rows != 0) {
	$i = 0;
	$result = dbquery(
		"SELECT s.shout_id, s.shout_name, s.shout_message, s.shout_datestamp, u.user_id, u.user_name, u.user_status, u.user_lastvisit
		FROM ".DB_SHOUTBOX." s
		LEFT JOIN ".DB_USERS." u ON s.shout_name=u.user_id
		WHERE s.shout_hidden='0'
		ORDER BY s.shout_datestamp DESC LIMIT ".$_GET['rowstart'].",20"
	);
	while ($data = dbarray($result)) {
	$row_color = ($i % 2 == 0 ? "row1" : "row2");
		echo "<div class='".$row_color."' style=' padding-bottom: 5px; padding-top: 5px;'>\n";

		if ((iADMIN && checkrights("S")) || (iMEMBER && $data['shout_name'] == $userdata['user_id'] && isset($data['user_name']))) {
			echo "<div class='options-main-archive'>\n<span class='options'><a href='".FUSION_SELF."?action=edit&amp;shout_id=".$data['shout_id']."'>".$locale['SB_edit']."</a></span>\n";
			echo "<span class='options'><a href='".FUSION_SELF."?action=delete&amp;shout_id=".$data['shout_id']."' onclick=\"return confirm('".$locale['SB_warning_shout']."');\">".$locale['SB_delete']."</a></span>\n</div>\n";
		}
		
		if ($data['user_name']) {
		  echo" <img class='stats-icon' src='".INFUSIONS."css_shoutbox_panel/images/stats.png' alt='".$data['user_name']." ".$locale['sb_001']." ".number_format(dbcount("(shout_id)", DB_SHOUTBOX, "shout_name='".$data['user_id']."'"))." ".$locale['sb_001']."' title='".$data['user_name']." ".$locale['sb_002']." ".number_format(dbcount("(shout_id)", DB_SHOUTBOX, "shout_name='".$data['user_id']."'"))." ".$locale['sb_001']."' />";
			
			echo "<span class='sb-name'>".profile_link($data['user_id'], $data['user_name'], $data['user_status'])."</span>\n";
		
		if ($data['user_lastvisit']<(time()-60)) {
				echo " <div class='sb-offline' title='".$data['user_name']." ".$locale['sb_off1']."'></div> \n";
			} else {
				echo " <div class='sb-online' title='".$data['user_name']." ".$locale['sb_on1']."'></div> \n";	
			}
		
		} else {
			echo "<span class='sb-name'>".$data['shout_name']."</span>\n";
		}
	
		echo "<span class='sb-date'>".showdate("longdate", $data['shout_datestamp'])."</span>";
			
		echo "</div>\n<div class='tbl1' style='padding-top: 12px; padding-bottom: 12px;'>\n".sbawrap(parseubb(parsesmileys($data['shout_message']), "b|i|u|url|color"))."";
	echo ' <div style="float:right; padding-bottom: 5px; padding-right: 5px;"><span class="options"><a title="@'.($data['user_name']?$data['user_name']:$data['shout_name']).'" href="javascript:insertText(\'archive_shout_message\',\'[b]@'.($data['user_name']?$data['user_name']:$data['shout_name']).':[/b] \', \'archive_form\');" class="small side">@</a></span></div>';
	echo"</div>\n";
		
	$i++;
	
	}
	
} else {
	echo "<div style='text-align:center'><br />\n".$locale['SB_no_msgs']."<br /><br />\n</div>\n";
}
closetable();

echo "<div align='center' style='margin-top:5px;'>\n".makepagenav($_GET['rowstart'], 20, $rows, 3, FUSION_SELF."?")."\n</div>\n";

require_once THEMES."templates/footer.php";
?>
